Empty variable macro problem

Hello, I'm having a problem in a macro on a single one of more than 20 workstations for 2 days (before it worked perfectly).
The Set swPart variable remains empty instead of populating as before
Set swPart = swChildComp.GetModelDoc2() to surrvol swPart = Nothing:

Sub TraverseComponent(swComp As SldWorks.Component2, nLevel As Long, catSelect As String)
    Dim vChilds As Variant, vChild As Variant
    Dim swChildComp As SldWorks.Component2
    Dim MyString As String
    Dim swCustPropMgr As SldWorks.CustomPropertyManager
    Set swApp = Application.SldWorks

    
    vChilds = swComp.GetChildren
    For Each vChild In vChilds
        Set swChildComp = vChild
        Dim FileName As String
        FileName = swChildComp.GetPathName
        Debug.Print "Part Name    : " & FileName
        FileName = Left(FileName, InStr(FileName, ".") - 1)
        FileName = Right(FileName, Len(FileName) - InStrRev(FileName, "\"))
        Debug.Print "Part Name    : " & FileName
        MyString = FileName
        Dim ActiveConfig As String
        ActiveConfig = swChildComp.ReferencedConfiguration
        Debug.Print "Configuration: " & ActiveConfig
        FileName = swChildComp.GetPathName
        If swChildComp.GetSuppression() <> swComponentSuppressionState_e.swComponentSuppressed Then
            Dim swIComp As IComponent2
            Set swIComp = swChildComp
            Dim notRepetition As Boolean
            notRepetition = swIComp.IsPatternInstance()
                Dim swPart As SldWorks.modelDoc2
                Set swPart = swChildComp.GetModelDoc2()
                'Récupère la catégorie de la configuration active
                Set swCustPropMgr = swPart.Extension.CustomPropertyManager(ActiveConfig) 'get properties
                categorie = swCustPropMgr.Get("Categorie") 'get categorie
                designation = swCustPropMgr.Get("Designation")
                'Si la catégorie de la config active est vide on récupère celle du document
                If categorie = "" Then
                    Set swCustPropMgr = swPart.Extension.CustomPropertyManager("") 'get properties
                    categorie = swCustPropMgr.Get("Categorie") 'get categorie
                    If designation = "" Then
                        designation = swCustPropMgr.Get("Designation") 'get categorie
                    End If
                End If
                
                Debug.Print "Catégorie: " & categorie
                    'If notRepetition = False Then
                        If catSelect = "FI" And notRepetition = False Then
                            folderName = "FI"
                            If (categorie = "Fourniture Industrielle" And Not (designation Like "STD*")) Or (categorie = "Tuyauterie") Or ((categorie = "Sans Catégorie") And (MyString Like "Bipod*")) Or ((categorie = "Sans Catégorie") And (MyString Like "Tripod*")) Then
                                compteur = compteur + 1
                                retVal = swChildComp.Select2(True, 0)
                            End If
                         ElseIf catSelect = "Visserie" And notRepetition = False Then
                            folderName = "Visserie"
                            'Debug.Print "Type:" & swPart.GetType
                            If (categorie = "Visserie") Or ((categorie = "Sans Catégorie") And (swPart.GetType = 2) And (Not MyString Like "Bipod*") And (Not MyString Like "Tripod*")) Then
                                compteur = compteur + 1
                                rRetVal = swChildComp.Select2(True, 0)
                            End If
                         ElseIf catSelect = "Reconductible" And notRepetition = False Then
                            folderName = "Reconductible"
                            'If categorie = "Reconductible" Then
                            If (categorie = "Reconductible") And (Not designation Like "STD*") Then
                                compteur = compteur + 1
                                retVal = swChildComp.Select2(True, 0)
                            End If
                         ElseIf catSelect = "Electricite" And notRepetition = False Then
                            folderName = "Electricité"
                            If categorie = "Electricite" Then
                                compteur = compteur + 1
                                retVal = swChildComp.Select2(True, 0)
                            End If
                          
                          ElseIf catSelect = "Produit" Then
                            folderName = "Produit"
                            If categorie = "Produit" Then
                                'Ligne pour exclure le composant de la nomenclature
                                swChildComp.SetExcludeFromBOM2 True, 2, 2
                                If categorie = "Produit" And notRepetition = False Then
                                    compteur = compteur + 1
                                    retVal = swChildComp.Select2(True, 0)
                                End If
                            End If
                        
                          ElseIf catSelect = "STD" And notRepetition = False Then
                            folderName = "STD"
                            If designation Like "STD*" Then
                                compteur = compteur + 1
                                retVal = swChildComp.Select2(True, 0)
                            End If
                        
                    'End If
            End If
            
        End If
        Debug.Print

    Next
    
End Sub

Does anyone have an explanation for this very strange and sudden behavior (no a priori update)
If necessary the full macro (above partial code)
CreateFolderByProperties.swp (118.5 KB)

Hello

No idea like that. Wouldn't Swchild also be empty?
By rolling it out step by step on the post in question, does it go normally?

1 Like

Hello

No instant ideas either: But I would look at the following points.

  1. The way the assembly is opened.
    (should be in " Resolved " and is probably in " Lite ")?

  2. the missing VB Supplements?
    (Unlikely should have error message)

  3. Solidworks " Performance " tab: Resolution under assemblies?
    (Compare with "functional" positions)
    image

  4. … The Lamp? (Ref: to an old advertisement whose sponsor I forgot...)

2 Likes

Hello @tous
It reminds me of the message " the object invoked has disconnected from its clients " the lighten, delete, hide and isloaded() tests were not enough, it's as if SW kicks them out of memory (it may be related to resource :stuck_out_tongue_winking_eye:optimization).
I propose to add a condition, if the object is empty then open the document from the component path.

1 Like

@sbadenis ... Any feedback on your investigations?

@Cyril.f swchild is not empty the 2 debugs. Print displays the variables well.

@Maclane, the investigations could not be deepened due to lack of time.
But the light mode (1 piece) does indeed cause this bug systematically. (as you thought)

I forced his settings on his post to be in resolution.

I'll probably have to add some code to check if the whole thing is solved. (In case of the same problem on another workstation)
If anyone has a piece of code about this that does the job, I'm all for it!

No doubt a lead here;
https://help.solidworks.com/2019/english/api/sldworksapi/Get_Component_State_Example_VB.htm

'---------------------------------------------------
' Preconditions:
' 1. Ensure that the specified assembly document
'    to open exists.
' 2. Open the Immediate window.
' 3. Run the macro.
'
' Postconditions:
' 1. Opens the assembly document.
' 2. Selects the subassembly.
' 3. Prints to the Immediate window:
'    * Paths to the assembly and subassembly documents
'    * Whether the component is hidden, fixed,
'      or suppressed
'    * Component's persistent ID
'    * Component's solving state
' 4. Examine the Immediate window.
'----------------------------------------------------

Option Explicit

Sub main()

    Dim swApp                       As SldWorks.SldWorks
    Dim swModel                     As SldWorks.ModelDoc2
    Dim swModelDocExt               As SldWorks.ModelDocExtension
    Dim swAssy                      As SldWorks.AssemblyDoc
    Dim swSelMgr                    As SldWorks.SelectionMgr
    Dim swComp                      As SldWorks.Component2
    Dim fileName                    As String
    Dim status                      As Boolean
    Dim errors                      As Long
    Dim warnings                    As Long

    Set swApp = Application.SldWorks

    ' Open assembly document
    fileName = "C:\Users\Public\Documents\SOLIDWORKS\SOLIDWORKS 2018\samples\tutorial\advdrawings\98food processor.sldasm"
    Set swModel = swApp.OpenDoc6(fileName, swDocASSEMBLY, swOpenDocOptions_e.swOpenDocOptions_Silent, "", errors, warnings)
    Set swModelDocExt = swModel.Extension
    

    ' Select subassembly
    status = swModelDocExt.SelectByID2("blade shaft-1@98food processor", "COMPONENT", 0, 0, 0, False, 0, Nothing, 0)
    Set swSelMgr = swModel.SelectionManager
    Set swAssy = swModel
    Set swComp = swSelMgr.GetSelectedObjectsComponent3(1, 0)
    

    ' Print to the Immediate window the path and state of the
    ' selected component
    Debug.Print "File = " & swModel.GetPathName
    Debug.Print "  Component   = " & swComp.Name2
    Debug.Print "    Path           = " & swComp.GetPathName
    Debug.Print "    IsHidden       = " & swComp.IsHidden(True)
    Debug.Print "    IsFixed        = " & swComp.IsFixed
    Debug.Print "    GetSuppression = " & swComp.GetSuppression
    Debug.Print "    ID             = " & swComp.GetID
    ' 0 =  if subassembly is rigid
    ' 1 =  if subassembly is flexible
    ' -1 = selected component is a part component
    Debug.Print "    Solving        = " & swComp.Solving

End Sub

and more specifically the " Solving " command

....    
Debug.Print "    Solving        = " & swComp.Solving
.....
1 Like

After a quick test

Debug.Print " Solving = " & swComp.Solving

Does not work for lightweight or solved parts, but for rigid, flexible or single-part assembly.
I continue my investigations!

1 Like

By adding this code, it detects if one or more components are in light of it and proposes to solve them:
image

And if the person clicks okay, the components become solved.
If she clicks on cancel it crashes as before on the unresolved component, but worse for her!

    Dim errors As Long
    errors = swAssy.ResolveAllLightWeightComponents(True)
    'Debug.Print ("All lightweight components resolved (0 = All components resolved)? " & errors)

Link to API code
https://help.solidworks.com/2021/english/api/sldworksapi/resolve_all_components_fix_a_component_example_vb.htm

1 Like